/**************************************************************
*
*                SERVIMEM.H
*
**************************************************************/
#include "..\include\portable.h"

/********************************************************************
*/
	unsigned __int32 read_int32(unsigned char *address) ;
/*
* needed in order to read a long integer
* from an odd address. This normally will lead to an address error. 
* The function "read_long" manages this problem by reading 
* byte by byte.
* 
* RETURN:  fixed length number read as 
*          unsigned long integer
* 
********************************************************************/

/********************************************************************
*/ 
	unsigned __int16 read_int16(unsigned char *address) ;
/*
* needed in order to read an integer
* from an odd address. This normally will lead to an address error. 
* The function "read_int" manages this problem by reading 
* byte by byte.
* 
* RETURN:  fixed length number read as 
*          unsigned integer
* 
********************************************************************/

/********************************************************************
*/
unsigned int read_var_len
	(
	unsigned char    *address, 
	unsigned __int32 *P_read_number, 
	unsigned char    *P_read_bytes
	) ;
/*
* Read a variable length number
* as described in the MIDI File Specification. 
* 
* INPUT:   address:  RAM address where the variable length number
*                    has to be read from
* OUTPUT:  *P_read_number:  variable length number read as 
*                             unsigned long integer
*          *P_read_bytes:  length of variable length number 
* RETURN:  0 = good, -1 = error 
* 
********************************************************************/

