/**************************************************************
*
*                SERVIMEM.CPP
*
**************************************************************/

#include "..\include\servimem.h"

#define max_bytes 4     /* a variable length number is composed of max.
                           4 bytes, see the MIDI file specification */


unsigned int read_var_len
(
	unsigned char    *address ,
	unsigned __int32 *read_number ,
	unsigned char    *read_bytes 
)
{
	unsigned __int32 buffer = 0 ;
	unsigned int     errors = 0 ;

	*read_bytes = 0 ;
	do
	{
		buffer = (buffer << 7) ;
		buffer = buffer | (unsigned __int32)(*address & 0x7f) ;
		address ++ ; 
		*read_bytes +=1 ;
		if (*read_bytes > max_bytes) errors = -1 ;
	} 
	while ( (!errors) && (*(address-1) & 0x80) ) ;
	*read_number = buffer ;
	return(errors) ;
}


unsigned __int32 read_int32(unsigned char *address)
{
	unsigned __int32 buffer ;

	*((unsigned char *)&buffer    ) = *(address    ) ;
	*((unsigned char *)&buffer + 1) = *(address + 1) ;
	*((unsigned char *)&buffer + 2) = *(address + 2) ;
	*((unsigned char *)&buffer + 3) = *(address + 3) ;
	return(buffer) ;
}


unsigned __int16 read_int16(unsigned char *address)
{
	unsigned __int16 buffer ;

	*((unsigned char *)&buffer    ) = *(address    ) ;
	*((unsigned char *)&buffer + 1) = *(address + 1) ;
	return(buffer) ;
}
